require 'dry/core/class_builder'

module Kraftwerk
  class App
    # Creates class holding app configuration
    def self.create_configuration!(namespace)
      klass = Class.new do
        extend Dry::Core::ClassAttributes

        defines :logger
        logger ::Logger.new($stdout)

        defines :reloading_enabled
        reloading_enabled ENV['RACK_ENV'] != 'production'

        defines :autoload_paths
        autoload_paths File.directory?('endpoints') ? ['endpoints'] : []

        defines :routing
      end

      namespace.const_set('Configuration', klass)
    end
  end
end
