require 'hanami/controller'
require 'kraftwerk/response_formatter'
require 'kraftwerk/endpoint/validatable'
require 'kraftwerk/endpoint/callable'
require 'kraftwerk/endpoint/error_handling'

module Kraftwerk
  module Endpoint
    def self.prepended(base_class)
      base_class.class_eval do
        include Hanami::Utils::ClassAttribute
        include Hanami::Action::Rack
        include Hanami::Action::Mime
        prepend Validatable
        prepend ErrorHandling
        prepend Callable
      end
    end
  end
end
